commit 30a66fb9616961264c291a4003ca1f41bebed5a1
Author: Rainer Orth <ro@CeBiTec.Uni-Bielefeld.DE>
Date:   Mon Aug 3 09:45:04 2020 +0200

    libsanitizer: Fix GetPcSpBp determination of SP on 32-bit Solaris/x86
    
    The latest Solaris 11.4/x86 update uncovered a libsanitizer bug that
    caused one test to FAIL for 32-bit:
    
    +FAIL: c-c++-common/asan/null-deref-1.c   -O0  output pattern test
    +FAIL: c-c++-common/asan/null-deref-1.c   -O1  output pattern test
    +FAIL: c-c++-common/asan/null-deref-1.c   -O2  output pattern test
    +FAIL: c-c++-common/asan/null-deref-1.c   -O2 -flto  output pattern test
    +FAIL: c-c++-common/asan/null-deref-1.c -O2 -flto -flto-partition=none
    output pattern test
    +FAIL: c-c++-common/asan/null-deref-1.c   -O3 -g  output pattern test
    +FAIL: c-c++-common/asan/null-deref-1.c   -Os  output pattern test
    
    I've identified the problem and the fix has just landed in upstream
    llvm-project:
    
            https://reviews.llvm.org/D83664
    
    Tested on i386-pc-solaris2.11 and x86_64-pc-linux.gnu.
    
            libsanitizer:
            * sanitizer_common/sanitizer_linux.cpp: Cherry-pick llvm-project
            revision f0e9b76c3500496f8f3ea7abe6f4bf801e3b41e7.

diff --git a/libsanitizer/sanitizer_common/sanitizer_linux.cpp b/libsanitizer/sanitizer_common/sanitizer_linux.cpp
index 3807a79b1cd..15ccd738d85 100644
--- a/libsanitizer/sanitizer_common/sanitizer_linux.cpp
+++ b/libsanitizer/sanitizer_common/sanitizer_linux.cpp
@@ -1924,13 +1924,13 @@ static void GetPcSpBp(void *context, uptr *pc, uptr *sp, uptr *bp) {
 # ifndef REG_EBP
 #  define REG_EBP  6 // REG_FP
 # endif
-# ifndef REG_ESP
-#  define REG_ESP 17 // REG_SP
+# ifndef REG_UESP
+#  define REG_UESP 17 // REG_SP
 # endif
 # endif
   *pc = ucontext->uc_mcontext.gregs[REG_EIP];
   *bp = ucontext->uc_mcontext.gregs[REG_EBP];
-  *sp = ucontext->uc_mcontext.gregs[REG_ESP];
+  *sp = ucontext->uc_mcontext.gregs[REG_UESP];
 # endif
 #elif defined(__powerpc__) || defined(__powerpc64__)
   ucontext_t *ucontext = (ucontext_t*)context;

